// Keehong Youn, 2018
// younkeehong@gmail.com

uniform mat4 modelview;
uniform mat4 projection;

uniform float time;

attribute vec4 position;
attribute vec4 color;

varying vec4 vertColor;

void main() {
  vec4 modified_pos = modelview * position;
  vec4 modified_color = color;

  if (gl_VertexID == 0) {
  	modified_color = vec4(1.0, 0.0, fract(time), 1.0);
  }
  if (gl_VertexID == 0) modified_pos.x += 30 * sin(10.0 * time);
  if (gl_VertexID == 1) modified_pos.y += 10 * sin(20.0 * time);

  gl_Position = projection * modified_pos;
  vertColor = modified_color;
}
