// Keehong Youn, 2018
// younkeehong@gmail.com

#ifdef GL_ES
precision mediump float;
precision mediump int;
#endif

uniform sampler2D texture;
uniform float blur;
// in from vertex shader
varying vec4 vertTexCoord;

void main() {
  vec4 tex_color = texture2D(texture, vertTexCoord.st);
  // if (gl_FragCoord.x > 256.0) {
  //   tex_color.b = 1.0;
  // }
  vec4 l = texture2D(texture, vertTexCoord.st + 5.0/512.0 * vec2(-1.0,  0.0));
  vec4 r = texture2D(texture, vertTexCoord.st + 5.0/512.0 * vec2( 1.0,  0.0));
  vec4 b = texture2D(texture, vertTexCoord.st + 5.0/512.0 * vec2( 0.0, -1.0));
  vec4 t = texture2D(texture, vertTexCoord.st + 5.0/512.0 * vec2( 0.0,  1.0));

  vec4 blur_color = 0.2 * (tex_color + l + r + b + t);
  vec4 result = mix(tex_color, blur_color, blur);
  gl_FragColor = result;
}