// Keehong Youn, 2018
// younkeehong@gmail.com

float t = 0;
float dt = 0.01;

PGraphics o; // 'o' for offscreen
PShader my_shader;

boolean do_blur = false;

void setup()
{
  size(512, 512, P3D);
  o = createGraphics(128, 128, P3D);
  my_shader = loadShader("shader.frag", "shader.vert");
}

void keyPressed()
{
  if (key == 'b') do_blur = !do_blur;
}

void draw()
{
  t += dt;

  background(255);

  // start drawing to offscreen
  o.beginDraw();
  o.background(0);
  
  o.noStroke();
  o.fill(255, 255, 0);
  o.rect(20, 20, 30, 30);

  o.fill(0, 255, 255);
  o.rect(80, 20, 30, 30);

  o.fill(255, 0, 255);
  o.rect(20, 80, 30, 30);

  o.fill(255, 255, 255);
  o.rect(80, 80, 30, 30);
  
  o.endDraw(); // done drawing to offscreen
  
  // sample and draw offscreen with custom fragment shader
  shader(my_shader);
  my_shader.set("blur", do_blur? 1.0 : 0.0);
  image(o, mouseX, mouseY, width / 2, height / 2);

}