// Keehong Youn, 2018
// younkeehong@gmail.com

// in from p5
uniform mat4 modelview; // model coord -> eye coord
uniform mat4 projection; // eye coord -> projection coord

uniform float time;

// in from p5
attribute vec4 position;
attribute vec4 color;

// out to frag shader
varying vec4 vertColor;

void main() {
  vec4 eye_pos = modelview * position; // pos will be changed in eye coord
  vec4 c = color; // copy incoming value so it can be changed

  // gl_VertexID has index of currently processing vertex
  if (gl_VertexID == 0) {
  	c = vec4(1.0, 0.0, fract(time), 1.0);
  }

  if (gl_VertexID == 0) eye_pos.x += 30 * sin(10.0 * time);
  if (gl_VertexID == 1) eye_pos.y += 10 * sin(20.0 * time);

  gl_Position = projection * eye_pos;
  vertColor = c;
}
